/***************************************************************************************
 *	File :	  editapi.cpp
 *	Company : PDADevelopers.com
 *	Author :  Diego Belfer 
 *	Last Revision : 28/09/2003 (dd/mm/yyyy)
 *	Comments : Builds a simple XML document using CPP wrapper
 ***************************************************************************************/


#include "ixml.h"
#include "common.h"


void editAPI() {
	char *buffer = sampleBuffer;

	HXML h = xml_create();

	XMLNode root;
	if ( (root = xml_createRoot(h)) ) {
		xml_appendChild(root, xml_createProcessingInstruction(h));
		XMLNode rows = xml_createElement(h, "rows");
		xml_appendChild(root, xml_createComment(h, "Clients recordset example"));
		xml_appendChild(root, rows);
		xml_appendAttribute(rows, xml_createAttribute(h, "recordset","clients"));

		for (int i = 0; i < dataCount; i++) {
			XMLNode record	= xml_createElement(h, "record");
			XMLNode address = xml_createElement(h, "address");
			XMLNode name	= xml_createElement(h, "name");
			XMLNode company = xml_createElement(h, "company");
			XMLNode info    = xml_createElement( h, "info" );
			XMLNode street  = xml_createElement(h, "street");
			XMLNode zipcode = xml_createElement(h, "zipcode");

			xml_appendChild( rows, record );
			xml_appendChild( record, name );
			xml_appendChild( record, company );
			xml_appendChild( record, info );
			xml_appendChild( record, address );
			xml_appendChild( address, street );
			xml_appendChild( address, zipcode);


			xml_appendAttribute( record, xml_createAttribute(h, "id",data[i].id) );

			xml_appendChild( name, xml_createTextNode(h, data[i].name ));
			xml_appendChild( company, xml_createTextNode(h, data[i].company ));
			xml_appendChild( info, xml_createCDATASection( h, data[i].info ) );
			xml_appendChild( street, xml_createTextNode(h, data[i].address.street ) );
			xml_appendChild( zipcode, xml_createTextNode(h, data[i].address.zip ) );
		}
		oprintln("--------------------------------");
		oprintln("*  XML builded by editapi.cpp  *");
		oprintln("--------------------------------");
		xml_toXML(h, buffer, SAMPLE_BUFFER_SIZE);
		oprintln(buffer);
	}
	xml_release(h);
}